<?php
/*
Plugin Name: Secrets
Plugin URI: http://meandmymac.net/plugins/secrets/
Description: Options which are otherwise hidden from everyone...
Author: Arnan de Gans
Version: 0.1
Author URI: http://meandmymac.net
*/ 

secrets_check_config();
add_action('admin_menu', 'secrets_add_pages');
add_action('template_redirect', 'secrets_header');

if(isset($_POST['secrets_submit_options']) AND $_GET['updated'] == "true") {
	add_action('init', 'secrets_options_submit');
}

function secrets_add_pages() {
	add_options_page('Secrets', 'Secrets', 10, basename(__FILE__), 'secrets_options_page');
}
$secrets_config = get_option('secrets_config');

/*-------------------------------------------------------------
 Name:      secrets_header

 Purpose:   Enable or disable filters and actions
 Receive:   -none-
 Return:    -none-
-------------------------------------------------------------*/
function secrets_header() {
	$secrets_config = get_option('secrets_config');
	
	if($secrets_config['livewriter'] == 0) {
		remove_action('wp_head', 'wlwmanifest_link');
		remove_action('wp_head', 'rsd_link');
	}
	
	if($secrets_config['postformatting'] == 0) {
		remove_filter('the_content', 'wpautop');
	}
}


/*-------------------------------------------------------------
 Name:      secrets_options_page

 Purpose:   Admin options page
 Receive:   -none-
 Return:    -none-
-------------------------------------------------------------*/
function secrets_options_page() {
	$secrets_config = get_option('secrets_config');
?>
	<div class="wrap">
	  	<h2>Secrets</h2>
	  	<form method="post" action="<?php echo $_SERVER['REQUEST_URI'];?>&amp;updated=true">
	    	<input type="hidden" name="secrets_submit_options" value="true" />

	    	<table class="form-table">

		      	<tr valign="top">
					<td colspan="2" bgcolor="#DDD"><span style="color:#f00; font-weight:bold;">WARNING: Use this page with caution! If you do not know what to do, don't use it!</span></td>
		      	</tr>

		      	<tr valign="top">
			        <td width="80%"><span style="font-weight:bold;">Windows Livewriter support</span></td>
			        <td><select name="livewriter">';
					<?php if($secrets_config['livewriter'] == 1) { ?>
				        <option value="1">enabled (default)</option>
						<option value="0">disabled</option>
					<?php } else { ?>
						<option value="0">disabled</option>
				        <option value="1">enabled (default)</option>
					<?php } ?>
					</select></td>
		      	</tr>

		      	<tr valign="top">
			        <td width="80%"><span style="font-weight:bold;">Autoformatting on posts</span></td>
			        <td><select name="postformatting">';
					<?php if($secrets_config['postformatting'] == 1) { ?>
				        <option value="1">enabled (default)</option>
						<option value="0">disabled</option>
					<?php } else { ?>
						<option value="0">disabled</option>
				        <option value="1">enabled (default)</option>
					<?php } ?>
					</select></td>
		      	</tr>
	    	</table>
		    <p class="submit">
		      	<input type="submit" name="Submit" value="Update Options &raquo;" />
		    </p>
		</form>
	</div>
<?php
}	

/*-------------------------------------------------------------
 Name:      secrets_check_config

 Purpose:   Create or update the options
 Receive:   -none-
 Return:    -none-
-------------------------------------------------------------*/
function secrets_check_config() {
	if ( !$option = get_option('secrets_config') ) {
		// Default Options
		$option['livewriter']			= 1;
		$option['postformatting']		= 1;
		update_option('secrets_config', $option);
	}
}

/*-------------------------------------------------------------
 Name:      secrets_options_submit

 Purpose:   Save options
 Receive:   $_POST
 Return:    -none-
-------------------------------------------------------------*/
function secrets_options_submit() {
	//options page
	$option['livewriter'] 				= $_POST['livewriter'];
	$option['postformatting'] 			= $_POST['postformatting'];
	update_option('secrets_config', $option);
}
?>